<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: Table of Contents</title><meta name="Description" content="Examples and tutorial for using iText, a free Java-Pdf library"><meta name="Keywords" content="PDF, JAVA, iText, examples, Lowagie, Bruno"><link rel="stylesheet" href="./style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>Table of Contents</h2><div id="content"><div class="title">Introduction:</div><a href="http://www.1t3xt.com/docs/book.php"><img align="right" border="0" src="http://www.1t3xt.com/img/book/lowagie_3d.jpg"></a><blockquote><p>
		iText is a library that allows developers to extend the capabilities of
		their web server (and other JAVA) applications with dynamic PDF document
		generation. In this tutorial, you will find lots of standalone examples
		to learn how to use most of the iText functionality and features.
		It should be easy to integrate most of the solutions in a Servlet, a
		Java Web Start application or some other Java program.
	</p><p>This tutorial is far from complete; for a more comprehensive
					overview of iText's functionality, please buy the book
					<a href="http://www.1t3xt.com/docs/book.php">iText in Action</a>.
					You can also download the first and third chapter for free from
					<a href="http://www.manning.com/affiliate/idevaffiliate.php?id=223_53">http://manning.com/lowagie/</a>.</p></blockquote><div class="title">Table of contents of this online tutorial</div><br><br><br><a name="part1"></a><div class="title">Part I: General Use of iText</div><div><a class="chapter" href="general/index.php" name="general">Hello World</a>How-to generate a PDF document with iText in 5 easy steps.</div><div><a class="chapter" href="general/webapp/index.php" name="general_webapp">iText in a Web Application</a>How-to use iText in Web Applications.</div><div><a class="chapter" href="general/copystamp/index.php" name="general_copystamp">Manipulating existing PDF documents</a>How-to copy/manipulate existing PDF documents.</div><div><a class="chapter" href="general/faq/index.php" name="general_faq">Frequently Asked Questions</a>This is a basic technical reference that answers some frequently asked questions.</div><a class="top" href="#top">Go to top of the page</a><a name="part2"></a><div class="title">Part II: Using Basic Building Blocks</div><div><a class="chapter" href="objects/index.php" name="objects">Basic Text Objects</a>Some basic text objects that are used in iText.</div><div><a class="chapter" href="objects/chunk/index.php" name="objects_chunk">The Chunk Object</a>Describes the functionality of the Chunk object.</div><div><a class="chapter" href="objects/anchors/index.php" name="objects_anchors">Anchors, Actions and Annotations</a>Deals with all the RemoteGoto, LocalGoto, Action, Annotation,... functionality</div><div><a class="chapter" href="objects/bookmarks/index.php" name="objects_bookmarks">Viewerpreferences, Pagelabels, Optional Content and Bookmarks</a>Deals with all the PDF Viewerpreferences, Bookmarks, Outlines, Destinations,... functionality</div><div><a class="chapter" href="objects/images/index.php" name="objects_images">Images</a>Deals with all types of images that are supported by iText</div><div><a class="chapter" href="objects/images/tiff/index.php" name="objects_images_tiff">Selected examples: EPS, TIFF, Barcodes</a>Selected examples: Embedding PostScript, importing TIFF files, Barcodes</div><div><a class="chapter" href="objects/tables/index.php" name="objects_tables">Tables</a>How to organize text and data in tables with iText</div><div><a class="chapter" href="objects/tables/pdfptable/index.php" name="objects_tables_pdfptable">PdfPTable</a>Some extra PdfPTable functionality</div><div><a class="chapter" href="objects/tables/alternatives/index.php" name="objects_tables_alternatives">Alternatives for PdfPTable</a>Some alternative ways to create a Table</div><div><a class="chapter" href="objects/columns/index.php" name="objects_columns">ColumnText</a>How to organize text and data in columns with iText</div><a class="top" href="#top">Go to top of the page</a><a name="part3"></a><div class="title">Part III: Fonts</div><div><a class="chapter" href="fonts/index.php" name="fonts">The Font objects</a>Describes the different Font objects in iText.</div><div><a class="chapter" href="fonts/styles/index.php" name="fonts_styles">Font characteristics</a>Changing the style of a Font.</div><div><a class="chapter" href="fonts/getting/index.php" name="fonts_getting">Getting fonts</a>Overview of the different types of fonts supported by iText.</div><a class="top" href="#top">Go to top of the page</a><a name="part4"></a><div class="title">Part IV: Direct Content</div><div><a class="chapter" href="directcontent/index.php" name="directcontent">Direct Content</a>Add content directly to the PDF file using the PdfContentByte class.</div><div><a class="chapter" href="directcontent/coordinates/index.php" name="directcontent_coordinates">Coordinate Systems</a>Coordinate Systems - changing the Current Transformation Matrix (CTM)</div><div><a class="chapter" href="directcontent/graphics/index.php" name="directcontent_graphics">Graphics State</a>Add graphics directly to the PDF file using the PdfContentByte class.</div><div><a class="chapter" href="directcontent/colors/index.php" name="directcontent_colors">Colors</a>Colors, Transparency, Spotcolors, Patterns and Shading.</div><div><a class="chapter" href="directcontent/text/index.php" name="directcontent_text">Text</a>Add text content directly to the PDF file using the PdfContentByte class.</div><div><a class="chapter" href="directcontent/pageevents/index.php" name="directcontent_pageevents">Page Events</a>Add content directly to the PDF file using the PdfContentByte class.</div><div><a class="chapter" href="directcontent/optionalcontent/index.php" name="directcontent_optionalcontent">Optional Content</a>Add optional content to a PDF file.</div><div><a class="chapter" href="directcontent/graphics2D/index.php" name="directcontent_graphics2D">Graphics2D</a>If you don't want to read all the chapters on PDF syntax, just use the JAVA API</div><a class="top" href="#top">Go to top of the page</a><a name="part5"></a><div class="title">Part V: Interactive Features (AcroForms)</div><div><a class="chapter" href="forms/index.php" name="forms">Interactive Forms</a>Step for step creation of an Acroform.</div><div><a class="chapter" href="forms/create/index.php" name="forms_create">Creating Forms</a>Step for step creation of an Acroform.</div><div><a class="chapter" href="forms/fill/index.php" name="forms_fill">Working with existing PDF documents</a>How-to copy/manipulate existing PDF documents.</div><a class="top" href="#top">Go to top of the page</a><a name="part6"></a><div class="title">Part VI: RTF</div><div><a class="chapter" href="rtf/index.php" name="rtf">Rich Text Format</a>How-to generate RTF documents using iText.</div><a class="top" href="#top">Go to top of the page</a><div id="footer" xmlns="http://www.w3.org/1999/xhtml">
			Page Updated: 2008-04-18 22:50:32
			Copyright &copy; 1999-2005
			<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=1932394796&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/1932394796/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0321304748&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a href="http://www.amazon.co.uk/exec/obidos/ASIN/0321304748/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=PDF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>