<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: Direct Content</title><meta name="Description" content="Support for direct content in RTF."><meta name="Keywords" content="JAVA, iText, RTF, examples"><link rel="stylesheet" href="./../../../style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>Direct Content</h2><div id="content"><div id="sidebar"><a class="toc" href="./../../../index.php#rtf_features_direct">
							Table of Contents
						</a><div class="sidetitle">Sections:</div><ul><li><a href="#pagenumbering">Direct Content</a></li><li><a href="#importing">Importing RTF documents</a></li></ul><br><br><div class="sidetitle">Examples:</div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/direct/SoftLineBreak.java">SoftLineBreak</a><br><div class="description">Generates a document demonstrating the use of soft linebreaks</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/direct/SoftLineBreak.rtf">SoftLineBreak.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./../../../rtf/features/direct/build.xml">
					build.xml
				</a></li></ul></div></div><div id="main"><a name="pagenumbering"></a><div class="title">Direct Content:</div><div xmlns="http://www.w3.org/1999/xhtml" xmlns:site="http://www.lowagie.com/iText/site">
    	  The RtfWriter2 provides components for most of the RTF specification,
    	  but not for everything. This is where the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/direct/RtfDirectContent.html">RtfDirectContent</a>
    	  comes into play. Using this object arbitrary RTF code can be added into the document "as is". The
    	  <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/direct/RtfDirectContent.html">RtfDirectContent</a> provides no further
    	  support for adding RTF content and it is up to the creator to specify correct RTF code.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  The <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/direct/RtfDirectContent.html">RtfDirectContent</a> provides
    	  one predefined constant and that is the RTF code for a soft line-break.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Add the contents before the linebreak
par.add("This paragraph contains a soft linebreak");

// Add the soft linebreak
par.add(RtfDirectContent.DIRECT_SOFT_LINEBREAK);

// Add the contents after the linebreak
par.add("just before the just.");
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/direct/SoftLineBreak.java">
						com.lowagie.examples.rtf.features.direct.SoftLineBreak</a><br>Generates a document demonstrating the use of soft linebreaks: see
						 <a href="/examples/com/lowagie/examples/rtf/features/direct/SoftLineBreak.rtf">SoftLineBreak.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="importing"></a><div class="title">Importing RTF documents:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  The RtfWriter2 also provides an interface for importing existing RTF documents via two
    	  methods
    	  <ul>
    	    <li><b>RtfWriter2.importRtfDocument</b>: Imports a complete RTF document. Will attempt
    	      to automagically translate the font and colour numbers in the original RTF document
    	      into the font and colour numbers used in the new RTF document.</li>
    	    <li><b>RtfWriter2.importRtfFragment</b>: Imports an RTF fragment. A <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/direct/RtfImportMappings.html">RtfImportMappings</a>
    	      must be provided that describes the mappings between the font and colour numbers in the imported
    	      RTF fragment to actual colours and font names.</li>
    	  </ul><br xmlns="http://www.w3.org/1999/xhtml">
    	  
    	  While the <span class="commandline">importRtfFragment</span> method is stable, the
    	  <span class="commandline">importRtfDocument</span> should currently be considered alpha quality code.
    	  Simple RTF documents should work, but complex documents can lead to problems.<br><br>
    	  
    	  More detailed documentation will be forthcoming, when the stability of the code improves.
    	</div><a class="top" href="#top">Go to top of the page</a><div id="footer">
			Page Updated: 2008-05-16 18:35:34
			Copyright &copy; 1999-2005
			Mark Hall<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0596004753&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/0596004753/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=RTF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>