<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: Page numbering</title><meta name="Description" content="Support for RTF page numbering."><meta name="Keywords" content="JAVA, iText, RTF, examples"><link rel="stylesheet" href="./../../../style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>Page numbering</h2><div id="content"><div id="sidebar"><a class="toc" href="./../../../index.php#rtf_features_pagenumber">
							Table of Contents
						</a><div class="sidetitle">Sections:</div><ul><li><a href="#pagenumbering">Page Numbering</a></li><li><a href="#totalpagenumber">Total Number of Pages</a></li></ul><br><br><div class="sidetitle">Examples:</div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/pagenumber/PageNumber.java">PageNumber</a><br><div class="description">Generates a document with page numbers in the footer</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/pagenumber/PageNumber.rtf">PageNumber.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/pagenumber/TotalPageNumber.java">TotalPageNumber</a><br><div class="description">Generates a document with page numbers and total number of pages in the header</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/pagenumber/TotalPageNumber.rtf">TotalPageNumber.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./../../../rtf/features/pagenumber/build.xml">
					build.xml
				</a></li></ul></div></div><div id="main"><a name="pagenumbering"></a><div class="title">Page Numbering:</div><div xmlns="http://www.w3.org/1999/xhtml" xmlns:site="http://www.lowagie.com/iText/site">
    	  Since RTF is rendered by the viewer and not on creation, the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/RtfWriter2.html">RtfWriter2</a>
    	  cannot calculate which page is currently being written. The <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/field/RtfPageNumber.html">RtfPageNumber</a>
    	  provides the functionality to overcome this with one limitation:
    	  
    	  <ul xmlns="http://www.w3.org/1999/xhtml">
    	    <li>It can only be used within the header or footer. In the main document it will not update correctly.</li>
    	  </ul><br>
    	  
    	  The <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/field/RtfPageNumber.html">RtfPageNumber</a> should not be used alone,
    	  but always wrapped in for example a <a href="http://www.1t3xt.info/api/com/lowagie/text/Paragraph.html">Paragraph</a> or
    	  <a href="http://www.1t3xt.info/api/com/lowagie/text/Table.html">Table</a> (see the example in the <a href="./../../../rtf/extensions/hf/index.php#">header/footers section</a>).
    	  This can then set as the header/footer via a <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/hf/RtfHeaderFooter.html">RtfHeaderFooter</a>.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Create a new Paragraph for the footer
Paragraph par = new Paragraph("Page ");
par.setAlignment(Element.ALIGN_RIGHT);

// Add the RtfPageNumber to the Paragraph
par.add(new RtfPageNumber());
            
// Create an RtfHeaderFooter with the Paragraph and set it
// as a footer for the document
RtfHeaderFooter footer = new RtfHeaderFooter(par);
document.setFooter(footer);
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/pagenumber/PageNumber.java">
						com.lowagie.examples.rtf.features.pagenumber.PageNumber</a><br>Generates a document with page numbers in the footer: see
						 <a href="/examples/com/lowagie/examples/rtf/features/pagenumber/PageNumber.rtf">PageNumber.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="totalpagenumber"></a><div class="title">Total Number of Pages:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  If the total number of pages should also be displayed, then a <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/field/RtfTotalPageNumber.html">RtfTotalPageNumber</a>
    	  can be added to the <a href="http://www.1t3xt.info/api/com/lowagie/text/Paragraph.html">Paragraph</a>.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Add the RtfTotalPageNumber to the Paragraph
par.add(" of ");
par.add(new RtfTotalPageNumber());

// Create an RtfHeaderFooter with the Paragraph and set it
// as a header for the document
RtfHeaderFooter header = new RtfHeaderFooter(par);
document.setHeader(header);
    	  </pre>
    	  
    	  One caveat here though:
    	  <ul>
    	    <li>The total number of pages is not always updated immediately. This is because Word uses a lazy
    	      approach to counting the total number of pages. Only if you scroll down the document, will the
    	      total page number be calculated correctly.</li>
    	  </ul>
    	  
    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/pagenumber/TotalPageNumber.java">
						com.lowagie.examples.rtf.features.pagenumber.TotalPageNumber</a><br>Generates a document with page numbers and total number of pages in the header: see
						 <a href="/examples/com/lowagie/examples/rtf/features/pagenumber/TotalPageNumber.rtf">TotalPageNumber.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><div id="footer" xmlns="http://www.w3.org/1999/xhtml">
			Page Updated: 2008-05-16 18:35:34
			Copyright &copy; 1999-2005
			Mark Hall<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0596004753&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/0596004753/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=RTF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>