<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: Drawing object</title><meta name="Description" content="Support for RTF Drawing Objects (Shapes)."><meta name="Keywords" content="JAVA, iText, RTF, examples"><link rel="stylesheet" href="./../../../style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>Drawing object</h2><div id="content"><div id="sidebar"><a class="toc" href="./../../../index.php#rtf_features_shape">
							Table of Contents
						</a><div class="sidetitle">Sections:</div><ul><li><a href="#drawingobjects">Drawing Objects</a></li><li><a href="#drawinganchor">Anchoring the Drawing Object</a></li><li><a href="#drawingwrap">Text Wrapping and Z-Order</a></li><li><a href="#drawingtext">Text in Drawing Objects</a></li><li><a href="#drawingfreeform">Freeform Objects</a></li></ul><br><br><div class="sidetitle">Examples:</div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingObjects.java">DrawingObjects</a><br><div class="description">Generates a document with one simple shape</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingObjects.rtf">DrawingObjects.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingAnchor.java">DrawingAnchor</a><br><div class="description">Generates a document demonstrating the use of different anchors for a drawing</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingAnchor.rtf">DrawingAnchor.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingWrap.java">DrawingWrap</a><br><div class="description">Generates a document demonstrating the different text wrapping modes</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingWrap.rtf">DrawingWrap.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingText.java">DrawingText</a><br><div class="description">Generates a document with text contained in the drawing object</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingText.rtf">DrawingText.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingFreeform.java">DrawingFreeform</a><br><div class="description">Generates a document demonstrating the creation of a freeform shape</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingFreeform.rtf">DrawingFreeform.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./../../../rtf/features/shape/build.xml">
					build.xml
				</a></li></ul></div></div><div id="main"><a name="drawingobjects"></a><div class="title">Drawing Objects:</div><div xmlns="http://www.w3.org/1999/xhtml" xmlns:site="http://www.lowagie.com/iText/site">
    	  Drawing objects make it possible to add arbitrary shapes to the RTF document.
    	  Shapes in RTF are represented as a few basic settings and then an arbitrary list
    	  of properties that represent all other aspects of the shape. Only for the most
    	  core properties are constants defined. For all further properties, please refer to
    	  the <a href="http://msdn2.microsoft.com/en-us/library/aa140277(office.10).aspx">RTF Specification 1.6</a>.<br><br>
    	  
    	  The basic class for creating drawing objects is the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShape.html">RtfShape</a>.
    	  It is made up out of an <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShapePosition.html">RtfShapePosition</a>,
    	  that defines the position of the the drawing object on the page and a list of <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShapeProperty.html">RtfShapeProperty</a>s,
    	  that specify all other properties that define the drawing object.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  The constructor for the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShape.html">RtfShape</a>
    	  takes the type of shape and an <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShapePosition.html">RtfShapePosition</a>.
    	  The <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShapePosition.html">RtfShapePosition</a> defines the
    	  extent of the drawing object (Important: These extents are in in <b xmlns="http://www.w3.org/1999/xhtml">Twips</b>) and also properties such as
    	  the z-order of the drawing object and whether the shape is above or below the main text.<br>
    	  To this the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShapeProperty.html">RtfShapeProperty</a> objects
    	  are added to define drawing object properties such as the line colour or fill colour.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Create a new RtfShape of the type RECTANGLE.
// The position defines the extent of the shape in the page (in Twips)
RtfShape shape = new RtfShape(RtfShape.SHAPE_RECTANGLE,
        new RtfShapePosition(1000, 2000, 3000, 2000));

// Set the line colour to red
shape.setProperty(new RtfShapeProperty(RtfShapeProperty.PROPERTY_LINE_COLOR,
        Color.RED));

// Set the fill colour to cyan
shape.setProperty(new RtfShapeProperty(RtfShapeProperty.PROPERTY_FILL_COLOR,
        Color.CYAN));

// Add the shape to the document
document.add(shape);
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingObjects.java">
						com.lowagie.examples.rtf.features.shape.DrawingObjects</a><br>Generates a document with one simple shape: see
						 <a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingObjects.rtf">DrawingObjects.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="drawinganchor"></a><div class="title">Anchoring the Drawing Object:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  By default the drawing object is anchored to the page, so that the values in
    	  the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShapePosition.html">RtfShapePosition</a>
    	  are applied relative to the top, left corner of the page. Other anchorings that are possible are:
    	  
    	  <ul xmlns="http://www.w3.org/1999/xhtml">
    	    <li>Horizontal anchoring
    	      <ul>
    	        <li><b>RtfShapePosition.POSITION_X_RELATIVE_PAGE:</b> The default, anchored to the page.</li>
    	        <li><b>RtfShapePosition.POSTIION_X_RELATIVE_MARGIN:</b> The horizontal position is relative to the margin of the page.</li>
    	        <li><b>RtfShapePosition.POSITION_X_RELATIVE_COLUMN:</b> The horizontal position is relative to the current column the shape is in.</li>
    	      </ul>
    	    </li>
    	    <li>Vertical anchoring
    	      <ul>
    	        <li><b>RtfShapePosition.POSITION_Y_RELATIVE_PAGE:</b> The default, anchored to the page.</li>
    	        <li><b>RtfShapePosition.POSTIION_Y_RELATIVE_MARGIN:</b> The horizontal position is relative to the margin of the page.</li>
    	        <li><b>RtfShapePosition.POSITION_Y_RELATIVE_PARAGRAPH:</b> The horizontal position is relative to the paragraph the shape is in. If the paragraph
    	          moves, the drawing object is moved with it.</li>
    	      </ul>
    	    </li>
    	  </ul><br>
    	  
    	  As an example the POSITION_Y_RELATIVE_PARAGRAPH anchoring can be used to create a horizontal line, separating two pieces of text.
    	  
    	  <pre class="commandline">
// Construct a new RtfShapePosition that covers the whole page horizontally 
RtfShapePosition position = new RtfShapePosition(150, 0, 10400, 150);

// The horizontal position is relative to the margins of the page
position.setXRelativePos(RtfShapePosition.POSITION_X_RELATIVE_MARGIN);

// The vertical position is relative to the paragraph
position.setYRelativePos(RtfShapePosition.POSITION_Y_RELATIVE_PARAGRAPH);
            
// Create a new line drawing object
RtfShape shape = new RtfShape(RtfShape.SHAPE_LINE, position);
            
// Add the shape to the paragraph, so that it is anchored to the
// correct paragraph
Paragraph par = new Paragraph();
par.add(shape);
document.add(par);
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingAnchor.java">
						com.lowagie.examples.rtf.features.shape.DrawingAnchor</a><br>Generates a document demonstrating the use of different anchors for a drawing: see
						 <a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingAnchor.rtf">DrawingAnchor.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="drawingwrap"></a><div class="title">Text Wrapping and Z-Order:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  By default <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShape.html">RtfShape</a>s are
    	  positioned above the text and the text does not wrap around them, but flow under them. Using
    	  the <span xmlns="http://www.w3.org/1999/xhtml" class="commandline">RtfShape.setWrapping</span>, <span class="commandline">RtfShapePosition.setBelowText</span>
    	  and <span class="commandline">RtfShapePosition.setZOrder</span> methods you can change these
    	  defaults.<br><br>
    	  
    	  Wrapping defines how the text flows around the drawing object. The following wrapping modes are supported:
    	  <ul>
    	    <li><b>SHAPE_WRAP_NONE</b>: The default. Text flows under or over the drawing object.</li>
    	    <li><b>SHAPE_WRAP_BOTH</b>: Text is wrapped around both sides of the drawing object, if there is space.</li>
    	    <li><b>SHAPE_WRAP_LEFT</b>: Text is wrapped around the left side of the drawing object, if there is space.</li>
    	    <li><b>SHAPE_WRAP_RIGHT</b>: Text is wrapped around the right side of the drawing object, if there is space.</li>
    	    <li><b>SHAPE_WRAP_LARGEST</b>: Text is wrapped around the largest free side of the drawing object.</li>
    	    <li><b>SHAPE_WRAP_THROUGH</b>: Text is wrapped through the drawing object.</li>
    	    <li><b>SHAPE_WRAP_TOP_BOTTOM</b>: No text will be placed to the left or right of the drawing object.</li>
    	    <li><b>SHAPE_WRAP_TIGHT_BOTH</b>: As SHAPE_WRAP_BOTH, but with less space between the text and the drawing object.</li>
    	    <li><b>SHAPE_WRAP_TIGHT_LEFT</b>: As SHAPE_WRAP_LEFT, but with less space between the text and the drawing object.</li>
    	    <li><b>SHAPE_WRAP_TIGHT_RIGHT</b>: As SHAPE_WRAP_RIGHT, but with less space between the text and the drawing object.</li>
    	    <li><b>SHAPE_WRAP_TIGHT_LARGETS</b>: As SHAPE_WRAP_LARGEST, but with less space between the text and the drawing object.</li>
    	  </ul><br>
    	  
    	  <pre class="commandline">
// Create an elliptical RtfShape, around which text will only wrap on the left side
position = new RtfShapePosition(3000, 6000, 10500, 4500);
shape = new RtfShape(RtfShape.SHAPE_ELLIPSE, position);
shape.setWrapping(RtfShape.SHAPE_WRAP_LEFT);
    	  </pre>
    	  
    	  Using the <span class="commandline">RtfShapePosition.setBelowText</span> method, you can define whether
    	  the text is above or below the drawing object, if no wrapping is set. If text wrapping is set,
    	  then this has no effect.
    	  
    	  <pre class="commandline">
// Create a rounded rectangle RtfShape and position it below the text
position = new RtfShapePosition(4000, 1500, 4500, 5000);
position.setShapeBelowText(true);
shape = new RtfShape(RtfShape.SHAPE_ROUND_RECTANGLE, position);
    	  </pre>
    	  
    	  Finally the <span class="commandline">RtfShapePosition.setZOrder</span> defines the z-order of
    	  the drawing objects, allowing you to stack shapes. The higher the z-order the further on top the
    	  stack the drawing object will be placed.
    	  
    	  <pre class="commandline">
// Create a circular RtfShape and set its z-order to 1
position = new RtfShapePosition(5850, 6800, 8200, 7250);
position.setZOrder(1);
shape = new RtfShape(RtfShape.SHAPE_ELLIPSE, position);
document.add(shape);

// Create a star RtfShape and set its z-order to 2, above the circle
// defined above
position = new RtfShapePosition(6000, 7000, 8000, 7000);
position.setZOrder(2);
    	  </pre>
    	  
    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingWrap.java">
						com.lowagie.examples.rtf.features.shape.DrawingWrap</a><br>Generates a document demonstrating the different text wrapping modes: see
						 <a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingWrap.rtf">DrawingWrap.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="drawingtext"></a><div class="title">Text in Drawing Objects:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  You can place text within the drawing objects using the <span class="commandline">RtfShape.setShapeText</span>
    	  method. This only allows placement of very simple text and does not support any formatting.
    	  
    	  <pre class="commandline">
// Set the text to display in the drawing object
shape.setShapeText("This text will appear in the drawing object.");
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingText.java">
						com.lowagie.examples.rtf.features.shape.DrawingText</a><br>Generates a document with text contained in the drawing object: see
						 <a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingText.rtf">DrawingText.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="drawingfreeform"></a><div class="title">Freeform Objects:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  The <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShape.html">RtfShape</a> provides a number
    	  of predefined shapes, but sometimes it is useful to be able to draw something more flexible.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  In this case the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShape.html">RtfShape</a>
    	  is created with the shape type <span xmlns="http://www.w3.org/1999/xhtml" class="commandline">SHAPE_FREEFORM</span>. In the second step
    	  the internal coordinate system is defined and finally the points of the shape are specified.
    	  For the internal coordinate system it is only necessary to specify the right and bottom values, as
    	  top and left default to 0. In the example these values are set to the width and height of the drawing
    	  object in Twips, but any values may be used and they will automatically be scaled to the size of the
    	  drawing object. The vertices of the drawing object are defined as an array of <span class="commandline">Point</span>
    	  objects. It is important to remember that the coordinates of the points are defined within the
    	  internal coordinate system and not the external one defined in the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/graphic/RtfShapePosition.html">RtfShapePosition</a>
    	  constructor.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Create a new rectangle RtfShape using the SHAPE_FREEFORM constant.
RtfShapePosition position = new RtfShapePosition(1000, 1000, 4000, 4000);
RtfShape shape = new RtfShape(RtfShape.SHAPE_FREEFORM, position);

// Set the bottom and right extents of the drawing object.
shape.setProperty(new RtfShapeProperty(RtfShapeProperty.PROPERTY_GEO_RIGHT, 3000));
shape.setProperty(new RtfShapeProperty(RtfShapeProperty.PROPERTY_GEO_BOTTOM, 3000));

// Define the vertices that make up the drawing object.
// This list draws a basic table shape.
shape.setProperty(new RtfShapeProperty(RtfShapeProperty.PROPERTY_VERTICIES,
    new Point[]{
        new Point(100, 100),
        new Point(2900, 100),
        new Point(2900, 200),
        new Point(2600, 200),
        new Point(2600, 1500),
        new Point(2520, 1500),
        new Point(2520, 200),
        new Point(480, 200),
        new Point(480, 1500),
        new Point(400, 1500),
        new Point(400, 200),
        new Point(100, 200)
    }));
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/shape/DrawingFreeform.java">
						com.lowagie.examples.rtf.features.shape.DrawingFreeform</a><br>Generates a document demonstrating the creation of a freeform shape: see
						 <a href="/examples/com/lowagie/examples/rtf/features/shape/DrawingFreeform.rtf">DrawingFreeform.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><div id="footer" xmlns="http://www.w3.org/1999/xhtml">
			Page Updated: 2008-05-16 18:35:34
			Copyright &copy; 1999-2005
			Mark Hall<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0596004753&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/0596004753/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=RTF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>