<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: RTF Stylesheet support</title><meta name="Description" content="Support for RTF stylesheets."><meta name="Keywords" content="JAVA, iText, RTF, examples"><link rel="stylesheet" href="./../../../style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>RTF Stylesheet support</h2><div id="content"><div id="sidebar"><a class="toc" href="./../../../index.php#rtf_features_styles">
							Table of Contents
						</a><div class="sidetitle">Sections:</div><ul><li><a href="#basictabs">Paragraph stylesheets</a></li><li><a href="#changingstyles">Changing stylesheet properties</a></li><li><a href="#extendingstyles">Extending the list of stylesheets</a></li></ul><br><br><div class="sidetitle">Examples:</div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/styles/BasicStylesheets.java">BasicStylesheets</a><br><div class="description">Generates a document demonstrating the use of paragraph stylesheets</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/styles/BasicStylesheets.rtf">BasicStylesheets.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/styles/ChangingStylesheets.java">ChangingStylesheets</a><br><div class="description">Generates a document with modified paragraph stylesheets</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/styles/ChangingStylesheets.rtf">ChangingStylesheets.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/styles/ExtendingStylesheets.java">ExtendingStylesheets</a><br><div class="description">Generates a document with new paragraph stylesheets</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/styles/ExtendingStylesheets.rtf">ExtendingStylesheets.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./../../../rtf/features/styles/build.xml">
					build.xml
				</a></li></ul></div></div><div id="main"><a name="basictabs"></a><div class="title">Paragraph stylesheets:</div><div xmlns="http://www.w3.org/1999/xhtml" xmlns:site="http://www.lowagie.com/iText/site">
    	  Paragraph stylesheets provide a method for grouping a number of font settings under
    	  one name. Additionally there are some styles that have special meaning, such as the
    	  default style and heading styles (see <a xmlns="" href="./../../../rtf/features/toc/index.php#">Table of contents</a> for an example).<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  The basic stylesheets are defined in <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfStylesheet.html">RtfStylesheet</a>
    	  There are four stylesheets defined by default:
    	  <ul xmlns="http://www.w3.org/1999/xhtml">
    	    <li><b>STYLE_NORMAL</b>: The default text style</li>
    	    <li><b>STYLE_HEADING_1, STYLE_HEADING_2, STYLE_HEADING_3</b>: Styles that define the top three heading levels.</li>
    	  </ul><br>
    	  
    	  Using the paragraph stylesheets is very simple. Just set them as the font for the
    	  <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/Paragraph.html">Paragraph</a> you wish to apply the style to.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Simply set the stylesheet you wish to use as the Font
// of the Paragraph
document.add(new Paragraph("This is a heading",
         RtfParagraphStyle.STYLE_HEADING_1));

document.add(new Paragraph("Just some text that is formatted " +
         "in the default style.", RtfParagraphStyle.STYLE_NORMAL));
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/styles/BasicStylesheets.java">
						com.lowagie.examples.rtf.features.styles.BasicStylesheets</a><br>Generates a document demonstrating the use of paragraph stylesheets: see
						 <a href="/examples/com/lowagie/examples/rtf/features/styles/BasicStylesheets.rtf">BasicStylesheets.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="changingstyles"></a><div class="title">Changing stylesheet properties:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  While using the default stylesheets as they are can sometimes be sufficient, often
    	  it will be necessary to adapt them to the requirements. To do this simply use the
    	  methods provided by the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfParagraphStyle.html">RtfParagraphStyle</a>
    	  on the default styles provided. Consult the javadoc for which properties can be changed.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  One thing that is important is that all changes must be done before <span class="commandline">document.open()</span>
    	  is called. Otherwise while the changes will be applied to the document content, the style
    	  definition will not match any more.
    	  
    	  <pre class="commandline">
// Set the default style font name. This is inherited
// by all other styles.
RtfParagraphStyle.STYLE_NORMAL.setFontName("Times New Roman");
// Set the colour of the level 1 heading to blue.
RtfParagraphStyle.STYLE_HEADING_1.setColor(Color.BLUE);
// Set the font name of the heading back to Arial again.
RtfParagraphStyle.STYLE_HEADING_2.setFontName("Arial");
// Change the font size
RtfParagraphStyle.STYLE_HEADING_2.setSize(12);
    	  </pre>
    	  
    	  Here it is important to note that the three heading styles all inherit from the default style.
    	  That means that any property that is not explicitly set in the style will take the inherited value.
    	  The result of this is that changing the font name for the default style will propagate to
    	  all other styles, unless a different font is set.

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/styles/ChangingStylesheets.java">
						com.lowagie.examples.rtf.features.styles.ChangingStylesheets</a><br>Generates a document with modified paragraph stylesheets: see
						 <a href="/examples/com/lowagie/examples/rtf/features/styles/ChangingStylesheets.rtf">ChangingStylesheets.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="extendingstyles"></a><div class="title">Extending the list of stylesheets:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  In some cases you might want to add your own stylesheets to the document. This basically
    	  comes down to creating your own <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfParagraphStyle.html">RtfParagraphStyle</a>
    	  object and then registering it with the <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfWriter2.html">RtfWriter2</a>.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  There are two ways for creating an <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfParagraphStyle.html">RtfParagraphStyle</a>
    	  
    	  <ul xmlns="http://www.w3.org/1999/xhtml">
    	    <li><b>With inheritance:</b> use the <span class="commandline">RtfParagraphStyle(name, basedOnName)</span>
    	      constructor, that inherits all unset properties from the RtfParagraphStyle specified by <span class="commandline">basedOnName</span>.
    	      This is especially useful if you want to create extensions of the default style.</li>
    	    <li><b>Without inheritance:</b> use the <span class="commandline">RtfParagraphStyle(styleName, fontName, fontSize, fontStyle, fontColor)</span>
    	      constructor to create an RtfParagraphStyle that does not inherit any unset properties.</li>
    	  </ul>
    	  
    	  In both cases it is important, that the name used to identify the new paragraph stylesheet is unique. After creating
    	  the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfParagraphStyle.html">RtfParagraphStyle</a> set all the other
    	  properties you wish to have.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  Finally you must register the new <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfParagraphStyle.html">RtfParagraphStyle</a>
    	  before calling <span xmlns="http://www.w3.org/1999/xhtml" class="commandline">document.open()</span>. Otherwise while the properties will
    	  be set, the stylesheet information won't be set correctly.
    	  
    	  <pre class="commandline">
// Create the new RtfParagraphStyle. The second parameter is the name of
// the RtfParagraphStyle that this style will inherit default properties from.
RtfParagraphStyle incorrectPar = new RtfParagraphStyle("Incorrect", "Normal");
// Change the desired properties
incorrectStyle.setColor(Color.RED);
incorrectStyle.setStyle(Font.STRIKETHRU);
// Register the new paragraph stylesheet with the RtfWriter2.
writer.getDocumentSettings().registerParagraphStyle(incorrectStyle);

// Create a new RtfParagraphStyle that does not inherit from any other style.
RtfParagraphStyle correctStyle = new RtfParagraphStyle("Correct", "Arial",
        12, Font.NORMAL, Color.GREEN);
// Register the new paragraph stylesheet with the RtfWriter2.
writer.getDocumentSettings().registerParagraphStyle(correctStyle);
    	  </pre>
    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/styles/ExtendingStylesheets.java">
						com.lowagie.examples.rtf.features.styles.ExtendingStylesheets</a><br>Generates a document with new paragraph stylesheets: see
						 <a href="/examples/com/lowagie/examples/rtf/features/styles/ExtendingStylesheets.rtf">ExtendingStylesheets.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><div id="footer" xmlns="http://www.w3.org/1999/xhtml">
			Page Updated: 2008-05-16 18:35:34
			Copyright &copy; 1999-2005
			Mark Hall<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0596004753&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/0596004753/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=RTF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>