<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: Tab support</title><meta name="Description" content="Support for tabs."><meta name="Keywords" content="JAVA, iText, RTF, examples"><link rel="stylesheet" href="./../../../style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>Tab support</h2><div id="content"><div id="sidebar"><a class="toc" href="./../../../index.php#rtf_features_tabs">
							Table of Contents
						</a><div class="sidetitle">Sections:</div><ul><li><a href="#basictabs">Tab support</a></li><li><a href="#tabgroups">Tab groups</a></li></ul><br><br><div class="sidetitle">Examples:</div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/tabs/BasicTabs.java">BasicTabs</a><br><div class="description">Generates a document demonstrating the use of tab stops</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/tabs/BasicTabs.rtf">BasicTabs.rtf</a></li></ul></div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/tabs/TabGroups.java">TabGroups</a><br><div class="description">Generates a document using the tab group feature</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/tabs/TabGroups.rtf">TabGroups.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./../../../rtf/features/tabs/build.xml">
					build.xml
				</a></li></ul></div></div><div id="main"><a name="basictabs"></a><div class="title">Tab support:</div><div xmlns="http://www.w3.org/1999/xhtml" xmlns:site="http://www.lowagie.com/iText/site">
    	  To support creating more complex RTF documents with tabular data, the
    	  <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/text/RtfTab.html">RtfTab</a> provides support
    	  for defining tab stops.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  To do this, simply add one or more <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/text/RtfTab.html">RtfTab</a>
    	  objects to the <a href="http://www.1t3xt.info/api/com/lowagie/text/Paragraph.html">Paragraph</a>. Then in
    	  the <a href="http://www.1t3xt.info/api/com/lowagie/text/Chunk.html">Chunks</a> use the "\t" tab
    	  character to specify where to place the tab stops.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Define the Paragraph to add tab stops to
Paragraph par = new Paragraph();
            
// Add the tab stops to the paragraph
par.add(new RtfTab(70, RtfTab.TAB_LEFT_ALIGN));
par.add(new RtfTab(400, RtfTab.TAB_RIGHT_ALIGN));
            
// Add the text to the paragraph, placing the tab stops with \t
par.add("\tFirst the text on the left-hand side\tThis text is right aligned.");
    	  </pre>
    	  
    	  The RtfTab takes two parameters:
    	  
    	  <ul>
    	    <li><b>position</b>: The horizontal position at which to place the tab stop.</li>
    	    <li><b>type</b>: The type of tab stop to place.
    	      <ul>
    	        <li><b>TAB_LEFT_ALIGN</b>: The text is left aligned on the tab stop position.</li>
    	        <li><b>TAB_RIGHT_ALIGN</b>: The text is right aligned on the tab stop position.</li>
    	        <li><b>TAB_CENTER_ALIGN</b>: The text is centre aligned on the tab stop position.</li>
    	        <li><b>TAB_DECIMAL_ALIGN</b>: The text is aligned on the decimal character. This might be different characters, depending on the locale setting.</li>
    	      </ul>
    	    </li>
    	  </ul><br><br>
    	  
    	  An important aspect to keep in mind is that if you use more then one tab stop per line,
    	  it is up to you to make sure that the text from the first tab stop does not overflow into
    	  the second tab stop. iText cannot check for this condition.<br>
    	  Also add the RtfTabs before you add the text, as otherwise the results might be undefined.    	  
    	  
    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/tabs/BasicTabs.java">
						com.lowagie.examples.rtf.features.tabs.BasicTabs</a><br>Generates a document demonstrating the use of tab stops: see
						 <a href="/examples/com/lowagie/examples/rtf/features/tabs/BasicTabs.rtf">BasicTabs.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="tabgroups"></a><div class="title">Tab groups:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  When repeatedly using the same grouping of <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/text/RtfTab.html">RtfTabs</a>
    	  in multiple <a href="http://www.1t3xt.info/api/com/lowagie/text/Paragraph.html">Paragraphs</a>, creating and
    	  adding them to each Paragraph is a lot of work. To simplify this, the
    	  <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/text/RtfTabGroup.html">RtfTabGroup</a> class is provided.
    	  It groups a set of RtfTab objects, that can then easily be added to multiple Paragraphs.<br xmlns="http://www.w3.org/1999/xhtml"><br>
    	  
    	  Its use is very simple. Create a new <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/text/RtfTabGroup.html">RtfTabGroup</a>
    	  object and then add the <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/text/RtfTab.html">RtfTab</a>
    	  to it using the <span xmlns="http://www.w3.org/1999/xhtml" class="commandline">RtfTabGroup.add(RtfTab)</span> method.
    	  
    	  <pre class="commandline">
// Construct the RtfTabGroup object
RtfTabGroup tabGroup = new RtfTabGroup();
// Add RtfTab tab stops at the desired positions
tabGroup.add(new RtfTab(400, RtfTab.TAB_RIGHT_ALIGN));
tabGroup.add(new RtfTab(500, RtfTab.TAB_DECIMAL_ALIGN));
            
// Create a Paragraph object
Paragraph par = new Paragraph();
// Add the tab group to the paragraph
par.add(tabGroup);
// Specify the tab positions using "\t"
par.add("Description\tDate\tAmount");
document.add(par);
    	  </pre>
    	  
    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/tabs/TabGroups.java">
						com.lowagie.examples.rtf.features.tabs.TabGroups</a><br>Generates a document using the tab group feature: see
						 <a href="/examples/com/lowagie/examples/rtf/features/tabs/TabGroups.rtf">TabGroups.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><div id="footer" xmlns="http://www.w3.org/1999/xhtml">
			Page Updated: 2008-05-16 18:35:34
			Copyright &copy; 1999-2005
			Mark Hall<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0596004753&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/0596004753/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=RTF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>