<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: RTF Table of Contents support</title><meta name="Description" content="Support for RTF TOCs."><meta name="Keywords" content="JAVA, iText, RTF, examples"><link rel="stylesheet" href="./../../../style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>RTF Table of Contents support</h2><div id="content"><div id="sidebar"><a class="toc" href="./../../../index.php#rtf_features_toc">
							Table of Contents
						</a><div class="sidetitle">Sections:</div><ul><li><a href="#toc">Creating a Table of Contents</a></li><li><a href="#tocentries">Adding Entries to the Table of Contents</a></li><li><a href="#tocstyle">Styling the Table of Contents</a></li></ul><br><br><div class="sidetitle">Examples:</div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.java">TableOfContents</a><br><div class="description">Generates a document with a table of contents</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.rtf">TableOfContents.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./../../../rtf/features/toc/build.xml">
					build.xml
				</a></li></ul></div></div><div id="main"><a name="toc"></a><div class="title">Creating a Table of Contents:</div><div xmlns="http://www.w3.org/1999/xhtml" xmlns:site="http://www.lowagie.com/iText/site">
    	  Creating a Table of Contents with the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/field/RtfTableOfContents.html">RtfTableOfContents</a>
    	  is very simple, but comes with three important caveats:
    	  
    	  <ul xmlns="http://www.w3.org/1999/xhtml">
    	    <li>The RtfWriter2 does not render the RTF document, thus it can't compute the page numbers for the table of contents.</li>
    	    <li>The RtfWriter2 only performs a single pass, thus the entries into the table of contents cannot be generated, even without page numbers.</li>
    	    <li>The RtfWriter2 cannot force the renderer to automatically update the table of contents on loading. The user must do this himself.</li>
    	  </ul><br>
    	  
    	  To add a table of contents, simply create a <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/Paragraph.html">Paragraph</a>
    	  and add a <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/field/RtfTableOfContents.html">RtfTableOfContetns</a> to it.
    	  The constructor takes one parameter and that is the text that will be initially displayed before the user
    	  updates the table of contents.
    	  
    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Create a Paragraph and add the table of contents to it
Paragraph par = new Paragraph();
par.add(new RtfTableOfContents("Right-click here and select \"Update\" " +
        "to see the table of contents."));
document.add(par);
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.java">
						com.lowagie.examples.rtf.features.toc.TableOfContents</a><br>Generates a document with a table of contents: see
						 <a href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.rtf">TableOfContents.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="tocentries"></a><div class="title">Adding Entries to the Table of Contents:</div><div xmlns="http://www.w3.org/1999/xhtml">
          The next step is adding entries to the table of contents. There is a <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/field/RtfTOCEntry.html">RtfTOCEntry</a>
          class, but its use is not recommended. The recommended method is using <a href="./../../../rtf/features/styles/index.php#">paragraph stylesheets</a>
          to define the different headers. By default header styles for the levels 1 to 3 are provided, but you can add more up to level 6.
          These header styles have a special side effect and that is that they automatically become part of the table of contents,
          when it is updated.

    	  <pre xmlns="http://www.w3.org/1999/xhtml" class="commandline">
// Create a level 1 heading
document.add(new Paragraph("Heading " + i, RtfParagraphStyle.STYLE_HEADING_1));
for(int j = 1; j &lt;= 3; j++) {
    // Create a level 2 heading
    document.add(new Paragraph("Heading " + i + "." + j, RtfParagraphStyle.STYLE_HEADING_2));
    	  </pre>

    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.java">
						com.lowagie.examples.rtf.features.toc.TableOfContents</a><br>Generates a document with a table of contents: see
						 <a href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.rtf">TableOfContents.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><a name="tocstyle"></a><div class="title">Styling the Table of Contents:</div><div xmlns="http://www.w3.org/1999/xhtml">
    	  Finally you can use the <a xmlns="" href="./../../../rtf/features/styles/index.php#">paragraph stylesheets</a> to style
    	  the resulting table of contents. To do this you must create an <a href="http://www.1t3xt.info/api/com/lowagie/text/rtf/style/RtfParagraphStyle.html">RtfParagraphStyle</a>
    	  for each heading level that you will use in the document. These styles must be named <span xmlns="http://www.w3.org/1999/xhtml" class="commandline">toc N</span>, where
    	  <span class="commandline">N</span> is the heading level that the style will apply to.
    	  
    	  <pre class="commandline">
// Create paragraph stylesheets for each heading level. They must be named
// "toc N" for each heading level you are using
RtfParagraphStyle tocLevel1Style = new RtfParagraphStyle("toc 1",
        "Times New Roman", 11, Font.NORMAL, Color.BLACK);
RtfParagraphStyle tocLevel2Style = new RtfParagraphStyle("toc 2",
        "Times New Roman", 10, Font.NORMAL, Color.BLACK);
tocLevel2Style.setIndentLeft(10);

// Register the paragraph stylesheets with the RtfWriter2
rtfWriter2.getDocumentSettings().registerParagraphStyle(tocLevel1Style);
rtfWriter2.getDocumentSettings().registerParagraphStyle(tocLevel2Style);
    	  </pre>
    	  
    	  <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.java">
						com.lowagie.examples.rtf.features.toc.TableOfContents</a><br>Generates a document with a table of contents: see
						 <a href="/examples/com/lowagie/examples/rtf/features/toc/TableOfContents.rtf">TableOfContents.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
    	</div><a class="top" href="#top">Go to top of the page</a><div id="footer" xmlns="http://www.w3.org/1999/xhtml">
			Page Updated: 2008-05-16 18:35:34
			Copyright &copy; 1999-2005
			Mark Hall<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0596004753&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/0596004753/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=RTF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>