<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><META http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>iText Tutorial: Rich Text Format</title><meta name="Description" content="How-to generate RTF documents using iText."><meta name="Keywords" content="PDF, JAVA, iText, RTF, examples, Lowagie, Bruno"><link rel="stylesheet" href="./../style.css" type="text/css"></head><body><a name="top" class="logo" href="http://www.lowagie.com/iText"><img src="http://www.lowagie.com/iText/images/logo.gif" border="0" alt="iText"></a><h1>Tutorial: iText by Example</h1><h2>Rich Text Format</h2><div id="content"><div id="sidebar"><a class="toc" href="./../index.php#rtf">
							Table of Contents
						</a><div class="sidetitle">Sections:</div><ul><li><a href="#rtfpackage">The RTF Package</a></li><li><a href="#introduction">Introduction to RTF</a></li><li><a href="#creatingrtf">Creating a basic RTF document</a></li><li><a href="#unsupported">Unsupported iText features</a></li></ul><br><br><div class="sidetitle">Examples:</div><div class="example"><a class="source" href="/examples/com/lowagie/examples/rtf/HelloWorld.java">HelloWorld</a><br><div class="description">Generates a simple 'Hello World!' RTF file</div><div class="small">Extra jars needed:</div><ul><li>itext-rtf.jar</li></ul><div class="small">Output:</div><ul><li><a href="/examples/com/lowagie/examples/rtf/HelloWorld.rtf">HelloWorld.rtf</a></li></ul></div><div class="example"><div class="small">ANT script (all examples):</div><ul><li><a href="./../rtf/build.xml">
					build.xml
				</a></li></ul></div></div><div id="main"><a name="rtfpackage"></a><div class="title">The RTF Package:</div><div xmlns="http://www.w3.org/1999/xhtml" xmlns:site="http://www.lowagie.com/iText/site">
		  The RTF package is an extension of the iText library and allows iText
		  to output Rich Text Files in additon to PDF files. These files can then
		  be viewed and edited with RTF viewers such as Microsoft Word or OpenOffice.org
		  Writer.
		</div><div>
		  The main class for generating RTF documents is the <a xmlns="" href="http://www.1t3xt.info/api/com/lowagie/text/rtf/RtfWriter2.html">RtfWriter2</a>.
		  It supports most of iText's features with the exception of those features listed
		  under the <a xmlns="http://www.w3.org/1999/xhtml" href="#unsupported">unsupported features</a>. In addition to this
		  there are a number of extensions to the core iText classes that provide access
		  to RTF specific functionality:<br><br>
		  <ul>
		    <li>Extensions to core classes
		      <ul>
		        <li><a xmlns="" href="./../rtf/extensions/font/index.php#">Extended font support</a></li>
		        <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/extensions/hf/index.php#">Extended header/footer support</a></li>
		        <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/extensions/table/index.php#">Extended table cell support</a></li>
		      </ul>
		    </li>
		    <li xmlns="http://www.w3.org/1999/xhtml">RTF specific features
		      <ul>
		        <li><a xmlns="" href="./../rtf/features/styles/index.php#">Paragraph stylesheets</a></li>
		        <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/features/tabs/index.php#">Tab support</a></li>
		        <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/features/toc/index.php#">Table of contents</a></li>
		        <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/features/pagenumber/index.php#">Page numbering</a></li>
		        <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/features/shape/index.php#">Drawing objects</a></li>
		        <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/features/direct/index.php#">Direct content</a></li>
		      </ul>
		    </li>
		    <li xmlns="http://www.w3.org/1999/xhtml"><a xmlns="" href="./../rtf/documentsettings/index.php#">RTF generation settings</a></li>
		  </ul>
		</div><a class="top" href="#top">Go to top of the page</a><a name="introduction"></a><div class="title">Introduction to RTF:</div><div xmlns="http://www.w3.org/1999/xhtml">
          RTF is the Rich Text Format developed by Microsoft with the aim of providing
          a cross-platform text-based document format. The main advantage that it has
          over PDF is that it can easily be edited with most word processing software.
          Its biggest disadvantage is that it is rendered by the word processing software
          when the RTF document is opened and not when the RTF document is generated.
          This leads to the situation that the document can look slightly different on
          different platforms.<br><br>
          It is important to remember that RTF is a document description format and
          when iText creates a RTF document, only the description of the document is
          generated. NO RENDERING TAKES PLACE. It is thus impossible to provide access
          to such things as page numbers or page events.<br><br>
          Apart from these considerations creating an RTF document works just like
          creating any other document with iText.
        </div><a class="top" href="#top">Go to top of the page</a><a xmlns="" name="creatingrtf"></a><div class="title">Creating a basic RTF document:</div><div xmlns="http://www.w3.org/1999/xhtml">
          Creating a basic RTF document works just like creating a basic PDF document:
          <pre class="commandline">
Document document = new Document();
RtfWriter2.getInstance(document,
	new FileOutputStream("testRTFdocument.rtf"));
document.open();
document.add(new Paragraph("Hello World!"));
document.close();
          </pre>
          <div id="example">
					Example: java
					<a xmlns="" href="/examples/com/lowagie/examples/rtf/HelloWorld.java">
						com.lowagie.examples.rtf.HelloWorld</a><br>Generates a simple 'Hello World!' RTF file: see
						 <a href="/examples/com/lowagie/examples/rtf/HelloWorld.rtf">HelloWorld.rtf</a><br>
						Extra jars needed in your CLASSPATH:
						 itext-rtf.jar<br></div>
          You can then use the objects described in <a href="./..//index.php#part2">Using High Level Objects</a>
          to create more complex RTF documents.
        </div><a class="top" href="#top">Go to top of the page</a><a name="unsupported"></a><div class="title">Unsupported iText features:</div><div xmlns="http://www.w3.org/1999/xhtml">
          A number of iText features are not supported in the RtfWriter2 due to the fact
          that they either have not been implemented or are not supported by the
          RTF format itself. The following list may not be complete, since the development
          of the RtfWriter2 sometimes lags behind the development of the core library.<br>
          <dl>
            <dt style="font-weight: bold">Images other than JPEG, PNG, BMP, GIF and WMF</dt>
            <dd>Only these image types are supported natively in the RTF format.</dd>
            <dt style="font-weight: bold">Rotated images</dt>
            <dd></dd>
            <dt style="font-weight: bold">Nested tables</dt>
            <dd></dd>
            <dt style="font-weight: bold">Embedded fonts</dt>
            <dd></dd>
            <dt style="font-weight: bold">Table.setSpaceInsideCell and Table.setSpaceBetweenCells</dt>
            <dd></dd>
            <dt style="font-weight: bold">Table.padding</dt>
            <dd></dd>
            <dt style="font-weight: bold">Watermarks</dt>
            <dd></dd>
            <dt style="font-weight: bold">Encryption</dt>
            <dd></dd>
            <dt style="font-weight: bold">Viewer preferences</dt>
            <dd>These only apply to the Adobe Acrobat Viewer.</dd>
            <dt style="font-weight: bold">Image borders</dt>
            <dd></dd>
            <dt style="font-weight: bold">Forms</dt>
            <dd></dd>
          </dl>
        </div><a class="top" href="#top">Go to top of the page</a><div id="footer">
			Page Updated: 2008-05-16 18:35:34
			Copyright &copy; 1999-2005
			Mark Hall<br><a href="http://www.lowagie.com/iText/">iText</a> is a Free Java-Pdf library by Bruno Lowagie and Paulo Soares.
		</div></div></div><div class="commercial"><br><div align="Center"><a href="http://www.prchecker.info/" target="_blank" title="iText, the #1 Java-PDF library"><img src="http://www.prchecker.info/PR1_img.gif" alt="iText, the #1 Java-PDF library" border="0"></a></div><br><br><script type="text/javascript"><!--
google_ad_client = "pub-0340380473790570";
google_ad_width = 120;
google_ad_height = 600;
google_ad_format = "120x600_as";
google_ad_channel ="";
google_ad_type = "text_image";
google_color_border = "FFFFFF";
google_color_bg = "FFFFFF";
google_color_link = "1B09BD";
google_color_url = "100670";
google_color_text = "707070";
//--></script><script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script><br><br><div class="subtitle">Amazon books:</div><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=8&l=as1&asins=0596004753&fc1=000000&lc1=0000ff&bc1=&lt1=_blank&IS2=1&bg1=ffffff&f=ifr" width="120" height="240" scrolling="no" marginwidth="0" marginheight="0" frameborder="0" align="Center"></iframe>');
//--></script><a xmlns="" href="http://www.amazon.co.uk/exec/obidos/ASIN/0596004753/catloogjecom-21" class="amazonlinks">
			amazon.co.uk-link
		</a><br><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=JAVA&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br><script type="text/javascript"><!--
document.write('<iframe src="http://rcm.amazon.com/e/cm?t=itisacatalofwebp&o=1&p=10&l=st1&mode=books&search=RTF&=1&fc1=&lc1=&lt1=&bg1=&f=ifr" width="120" height="460" border="0" frameborder="0" style="border:none;" scrolling="no" marginwidth="0" marginheight="0"></iframe>');
//--></script><br></div><script src="http://www.google-analytics.com/urchin.js" type="text/javascript"></script><script type="text/javascript">_uacct = "UA-1749025-1";urchinTracker();</script></body></html>